Subject: FYI: superlinear speedups in GROMACS

From: Eugene Leitl <[email-masked]>
Date: Fri, 8 Mar 2002 12:00:45 +0100 (MET)

---------- Forwarded message ----------
Date: Thu, 7 Mar 2002 23:24:49 -0500
From: 'Velocet' <[email-masked]>
To: Jim Fraser <[email-masked]>
Cc: [email-masked]
Subject: Re: DUAL CPU board  vs 2 Single CPU boards:  bang for buck?

On Thu, Mar 07, 2002 at 12:45:26PM -0500, Jim Fraser's all...
> Amazing. 1 cpu 63 ps/day, 2 cpu = 179 ps/day, sounds like a case of  1 + 1 =
> 2.84   (ie. 63 + 63 = 179 (not 126)?)
> Sounds fishy to me but I am unfamiliar with your application.

Ask David VanDerSpoel, he'll tell you that they see superlinear speedups
in Gromacs jobs quite often. Has to do with the cache, I'd guess something
like with one CPU the job cant fit in L2 cache by itself, so lots of
main memory accesses are required - when the job is split for 2 cpus,
more of the job is in L2 caches, and despite the shared memory that LAM
uses for communications for dual nodes, the overhead for that doesnt outweigh
the advantage of having the job divided into more cache ram... works
out well! :)

It happens sometimes - they see 20-25% for Pentium (3? 4?) in speedups, but
Athlons really kick ass for CERTAIN JOBS in gromacs (small jobs dont do this
because one CPU is enough for the whole job, and MONSTER jobs may well be too
big for the cache to give a big advantage - and once you go onto a network it
may too slow to take advantage of directly (dotn know if people have scali
numbers for gromacs 3.0 on Dual athlons >=1.2GHz) - I see >100% scaling per
CPU with 4 nodes with GBE with that job (d.dppc) in gromacs 3.0 with 1.333
Ghz CPUs.

[ im not sure this is all how it works, perhaps someone on the list can
explain it. ]

Go read the factoring hack by DJB I think it was that makes RSA style public
key easier by a magnitude or so (couple weeks ago) - there are big speedups
for that stuff due to multiple CPU cache usage... it seems somewhat related.

/kc

> Jim
>
> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]]On
> Behalf Of Velocet
> Sent: Thursday, March 07, 2002 11:00 AM
> To: [email-masked]
> Subject: Re: DUAL CPU board vs 2 Single CPU boards: bang for buck?
>
>
> On Thu, Mar 07, 2002 at 07:24:08AM -0500, Jim Fraser's all...
> > I don't desire to start a flame but it seems to me that for computational
> > intensive and memory intensive work that 2 singles are better and in most
> > cases cheaper then a dual setup.  The dual SMP systems out there now have
> to
> > fight for bandwidth along the same bus.  The AMD chips while fast appear
> to
> > be starved for data when *big* memory jobs are running.  Further I don't
> see
> > the cost benefits, if you actually dig into the "bang-for-buck" duals
> never
> > seem to win.
>
> Counter example:
>
> d.dppc on gromacs 3.0 calculation on a dual tyan 2460 board:
>
> 1 cpu 63 ps/day
> dual cpu 179 ps/day
>
> cache, baby.
>
> now, if only we could get 8 way athlons!
>
> /kc
>
> > The only significant benefit I see from dual is less hardware and higher
> > computing density, that may be reason enough to go with duals esp. if your
> > application does not require a lot of memory fetches.
>
>
> >
> > Jim Fraser
> >
> > _______________________________________________
> > Beowulf mailing list, [email-masked]
> > To change your subscription (digest mode or unsubscribe) visit
> http://www.beowulf.org/mailman/listinfo/beowulf
>
> --
> Ken Chase, [email-masked]  *  Velocet Communications Inc.  *  Toronto,
> CANADA
> _______________________________________________
> Beowulf mailing list, [email-masked]
> To change your subscription (digest mode or unsubscribe) visit
> http://www.beowulf.org/mailman/listinfo/beowulf
>

-- 
Ken Chase, [email-masked]  *  Velocet Communications Inc.  *  Toronto, CANADA
_______________________________________________
Beowulf mailing list, [email-masked]
To change your subscription (digest mode or unsubscribe) visit http://www.beowulf.org/mailman/listinfo/beowulf